Attribute VB_Name = "Playlist"

Public Function SaveM3U(ByVal StrFileName As String, ByRef strFilePaths() As String) As Boolean
Open StrFileName For Output As #1
    Print #1, "#EXTM3U"
    Dim i
    For i = LBound(strFilePaths) To UBound(strFilePaths)
    Print #1, "#EXTINF:0," & Dir(strFilePaths(i))
    Print #1, strFilePaths(i) + vbNewLine
    
    Next
Close #1
End Function

Public Function SaveM(path, wPaths As Collection)
Dim a As New Collection
Set a = wPaths
ff = FreeFile
Open path For Output As ff
Print #ff, "#EXTM3U"
For i = 1 To a.Count
Print #ff, "#EXTINF:0," & Dir(a.Item(i))
Print #ff, a.Item(i) + vbNewLine
Next
Close ff
End Function

Public Function LoadM3U(ByVal StrFileName As String, ByRef strFilePaths() As String, ByRef strNames() As String) As Boolean
    
   'Error handler
   On Error GoTo ErrHap
    
       'Declare variables
       Dim lngFileNo As Long
       Dim strTemp As String
       Dim i As Long
       Dim strLines() As String
       Dim lngLines As Long
       Dim strM3ULoc As String
        
       'Check if file exists
       If Dir(StrFileName) <> "" Then
            
           'Get M3U location
           strM3ULoc = Left$(StrFileName, InStrRev(StrFileName, "\"))
            
           'Get new file number
           lngFileNo = FreeFile
            
           'Open the file
           Open StrFileName For Input As lngFileNo
                
               'Get the file
               strTemp = Input(LOF(lngFileNo), #lngFileNo)
                
           Close lngFileNo
            strTemp = Replace(strTemp, vbNewLine + vbNewLine, vbCrLf)
           'Split the file into it's lines
           strLines = Split(strTemp, vbCrLf)
            
           'Check that this file has enough lines
           If UBound(strLines) > 2 Then
            
               'Check that it's an M3U file
               If strLines(0) = "#EXTM3U" Then

                   'Get number of lines
                   lngLines = UBound(strLines)
                    
                   'Attention! If you have any errors over the next 2 lines then you need to make sure
                   'that you have declared the array variables without specifying their size,
                   'because here we're changing their sizes to match.  - Thanks
                   ReDim strFilePaths(0 To (lngLines / 2)) As String
                   ReDim strNames(0 To (lngLines / 2)) As String

                   'Loop through each line
                   For i = 1 To lngLines
                    
                       'Check what kind of data we've got
                       If Left$(strLines(i), 7) = "#EXTINF" Then
                            
                           'File name & length (but we don't return that). Get file name
                           strNames((i - 1) / 2) = Right$(strLines(i), Len(strLines(i)) - InStr(1, strLines(i), ","))
                            
                       Else
                           'File path. Verify the path
                           If Dir(strLines(i)) <> "" Then
                               'Pure path, including drive letter
                               strFilePaths((i / 2) - 1) = strLines(i)
                           ElseIf Dir(strM3ULoc & strLines(i)) <> "" Then
                               'Adding onto the M3U's path (most common)
                               strFilePaths((i / 2) - 1) = strM3ULoc & strLines(i)
                           ElseIf Dir(Left$(strM3ULoc, 3) & strLines(i)) <> "" Then
                               'Adding onto the M3U's drive only
                               strFilePaths((i / 2) - 1) = Left$(strM3ULoc, 3) & strLines(i)
                           Else
                               'Display error message
                               Call MsgBox("Cannot find file!" & vbCrLf & strLines(i), vbExclamation, "Error while loading a file!")
                           End If
                       End If
                        
                   Next i
                    
                   'Set return value to true
                   LoadM3U = True
                
               End If
                
           Else
               'Return error
               LoadM3U = False
           End If
 Else
           'Return error
           LoadM3U = False
       End If
Exit Function
ErrHap:
   'Check error
   If Err.Number = 10 Then
       'Display message and exit function
       Call MsgBox("Cannot accept fixed length arrays!", vbExclamation, "Error - Function 'LoadM3U'")
       Exit Function
   End If
'Display error
   Call MsgBox(Err.Description & " Number: " & Err.Number, vbExclamation)
 'Set return value
   LoadM3U = False
End Function

Public Function LoadM(path As String) As Collection

Dim lngFileNo, strTemp, lines, pLines As New Collection, PM3U
lngFileNo = FreeFile
PM3U = Left(path, InStrRev(path, "\"))
Open path For Input As lngFileNo
                
               'Get the file
               strTemp = Input(LOF(lngFileNo), #lngFileNo)
                
           Close lngFileNo
           
           lines = Split(strTemp, vbNewLine)
           
           For i = LBound(lines) To UBound(lines)
            If Left(lines(i), 7) = "#EXTINF" Then
            Else
            If Dir(Trim(lines(i))) <> "" Then
                       
            If lines(i) <> "" Then pLines.Add lines(i)
            Else
             If Dir(PM3U + lines(i)) <> "" Then
             If lines(i) <> "" Then pLines.Add PM3U + lines(i)
             End If
            End If
            End If
           Next
           Set LoadM = pLines
           
End Function
